<?php
/////////////////////////////////////////////
//
// CAPTCHA generator v2.01
// Last modified: Thu, 27 December 2007 01:18:00 GMT
//
/////////////////////////////////////////////

/////////////////////////////////////////////
//
// Error Codes
//
// 1 = No hash received
// 2 = Font directory does not exist or is not readable
// 3 = No font files loaded (freetype)
// 4 = No font files loaded (not freetype)
//
/////////////////////////////////////////////

// Lets grab the database username to use as a key
$include_path = dirname(__FILE__);
require_once $include_path.'/admin/config.inc.php';
require_once $include_path.'/lib/mysql.class.php';
require_once $include_path.'/lib/vars.class.php';
require_once $include_path.'/lib/template.class.php';

$db = new guestbook_vars($include_path);
$db->getVars();

$usecolor = ($db->VARS['captcha_grey']) ? 0 : 1;

$thekey = (!empty($GB_DB['user'])) ? $GB_DB['user'] : 'Lazarus';

// create an image with width 120px, height 20px
$image = imagecreatetruecolor(200, 40);

// Assign a background colour
$background = imagecolorallocate($image, 255,255,255);

// Fill it in with the background colour
imagefilledrectangle($image, 0, 0, 199, 39, $background);

// Have we got a timehash to work with?

$hash = (!empty($_GET['hash'])) ? $_GET['hash'] : '';

function display_error($error_number)
{
   global $image;
   $red = imagecolorallocate($image, 255, 0, 0);
   imagestring($image, 5, 2, 3, 'ERROR! ('.$error_number.')', $red);
   // Do our headers
   header('Cache-Control: no-cache');
   header('Pragma: no-cache');
   header("Expires: Sat, 1 Jan 2000 00:00:00 GMT");
   if (function_exists('imagepng'))
   {
      header('Content-type: image/png');
      // Dump the image
      imagepng($image);
   }
   else
   {
      header('Content-type: image/jpeg');
      // Dump the image
      imagejpeg($image, '', 100);
   }
   // Tidy up
   imagedestroy($image); 
   exit();   
}

if (!empty($hash) && is_numeric($hash))
{

   // generate some random stuff for the text
   $realcode = strtoupper(md5(time()));

   // Better make sure they have freetype installed
   $freetype = (function_exists('imagettftext')) ? true : false;
   
   $fontDir = $include_path.'/fonts/';
   
   if (is_dir($fontDir) && is_readable($fontDir))
   {
      // Set our fonts
      if ($freetype)
      {
			chdir($fontDir);
			$handle = opendir('.');
			$font_count = 0;
			while ($file = readdir($handle)) 
         {
				if (preg_match("/\.ttf/i", $file) && is_readable($file)) 
            {
					$font[] = ($fontDir.'/'.$file);
					$font_count++;
				}
			}
			closedir($handle);
         if ($font_count == 0)
         {
            display_error(3);
         }            
      }
      else
      {
			chdir($fontDir);
			$handle = opendir('.');
			$font_count = 0;
			while ($file = readdir($handle))
         {
				if (preg_match("/\.gdf/i", $file) && is_readable($file))
            {
					$font[] = imageloadfont($fontDir.'/'.$file);
					$font_count++;
				}
			}
			closedir($handle);
         if ($font_count == 0)
         {
            display_error(4);
         }               
      }
   }
   else
   {
      display_error(2);    
   }

   // Do we want lines?
   if ($db->VARS['captcha_grid'])
   {
      // Generate the lines then
      for ($i = 1; $i <= 3; $i++)
      {
         $grey = mt_rand(30, 120);
         $red = ($usecolor) ? mt_rand(40, 140) : $grey;
         $green = ($usecolor) ? mt_rand(40, 140) : $grey;
         $blue = ($usecolor) ? mt_rand(40, 140) : $grey;
         $thecolor = imagecolorallocate($image, $red, $green,$blue);
         imagesetthickness($image, mt_rand(1, 3));
         imageline($image, mt_rand(1, 199), mt_rand(1, 39), mt_rand(1, 199), mt_rand(1, 39), $thecolor);
      }
   }

   // Here we add our code to the image
   // First create our code
   $realcode = '';
   $realcode = md5($thekey) . md5($hash);
   $realcode = strtoupper(md5($realcode));
   // Just an array for turning numbers into letters
   $captchanum = array(0 => 'V', 1 => 'H', 2 => 'K', 3 => 'M', 4 => 'P', 5 => 'S', 6 => 'T', 7 => 'W', 8 => 'X', 9 => 'Z');
   $xpos = mt_rand(5, 20); // set a random horizontal starting position
   for ($i = 0;$i <= 30;$i += 7)
   {
      $grey = mt_rand(30, 120);
      $red = ($usecolor) ? mt_rand(40, 140) : $grey;
      $green = ($usecolor) ? mt_rand(40, 140) : $grey;
      $blue = ($usecolor) ? mt_rand(40, 140) : $grey;
      $thecolor = imagecolorallocate($image, $red, $green, $blue);
      $realcode[$i] = (is_numeric($realcode[$i])) ? $captchanum[$realcode[$i]] : $realcode[$i];
      if ($freetype)
      {
         $fontface = mt_rand(0,(count($font)-1)); // Select a font face at random
         $fontsize = mt_rand(14, 18);
         $fontangle = mt_rand(-20, 20);
         imagettftext($image, $fontsize, $fontangle, $xpos, mt_rand(24, 36), $thecolor, $font[$fontface], $realcode[$i]);
         $nextstart = imagettfbbox($fontsize, $fontangle, $font[$fontface], $realcode[$i]);
         $xpos += ($nextstart[2] > $nextstart[4]) ? $nextstart[2] + mt_rand(1, 24) : $nextstart[4] + mt_rand(1, 24); // Move the horizontal position along
      }
      else
      {
         $fontface = mt_rand(0,(count($font)-1));
         $vertpos = mt_rand(0, (45 - imagefontheight($font[$fontface])));
         imagechar($image, $font[$fontface], $xpos, $vertpos, $realcode[$i], $thecolor);
         $xpos += (mt_rand(3, 18) + imagefontwidth($font[$fontface]));
      }
   }

   // Do we want the noise? I don't think I will make this an option
   if ($db->VARS['captcha_noise'])
   {
      for ($i = 1; $i <= 39; $i++)
      {
         for($j = 1; $j <= 30; $j++)
         {
            $grey = mt_rand(30, 120);
            $red = ($usecolor) ? mt_rand(40, 140) : $grey;
            $green = ($usecolor) ? mt_rand(40, 140) : $grey;
            $blue = ($usecolor) ? mt_rand(40, 140) : $grey;
            $thecolor = imagecolorallocate($image, $red, $green, $blue);
            imagesetpixel($image, mt_rand(1, 199), $i, $thecolor);
         }
      }
   }
}
else // We've not got a hash so report an error
{
   display_error(1);
} 

// Do our headers
header('Cache-Control: no-cache');
header('Pragma: no-cache');
header("Expires: Sat, 1 Jan 2000 00:00:00 GMT");
if (function_exists('imagepng'))
{
   header('Content-type: image/png');
   // Dump the image
   imagepng($image);
}
else
{
   header('Content-type: image/jpeg');
   // Dump the image
   imagejpeg($image, '', 90);
}
// Tidy up
imagedestroy($image);
?>